# Enum DeferrableOutputStream.State

java.lang.Object
java.lang.Enum<DeferrableOutputStream.State>
org.apache.commons.fileupload2.core.DeferrableOutputStream.State

All Implemented Interfaces:
  `Serializable, Comparable<DeferrableOutputStream.State>`

Enclosing class:
  `DeferrableOutputStream`

public static enum DeferrableOutputStream.State extends Enum<DeferrableOutputStream.State>
This enumeration represents the possible states of the `DeferrableOutputStream`.

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`closed`
The stream has been closed, and data can no longer be written.
`initialized`
The stream object has been created with a non-negative threshold, but so far no data has been written.
`opened`
The stream object has been created with a non-negative threshold, and some data has been written, but the threshold is not yet exceeded, and the data is still kept in memory.
`persisted`
Either of the following conditions is given: The stream object has been created with a threshold of -1, or the stream object has been created with a non-negative threshold, and some data has been written.

## Method Summary

Modifier and Type
Method
Description
`static DeferrableOutputStream.State`
`valueOf(String name)`
Returns the enum constant of this type with the specified name.
`static DeferrableOutputStream.State[]`
`values()`
Returns an array containing the constants of this enum type, in the order they are declared.

### Methods inherited from class Enum

`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### initialized

public static final DeferrableOutputStream.State initialized
The stream object has been created with a non-negative threshold, but so far no data has been written.

### opened

public static final DeferrableOutputStream.State opened
The stream object has been created with a non-negative threshold, and some data has been written, but the threshold is not yet exceeded, and the data is still kept in memory.

### persisted

public static final DeferrableOutputStream.State persisted
Either of the following conditions is given:

1. The stream object has been created with a threshold of -1, or
2. the stream object has been created with a non-negative threshold, and some data has been written. The number of bytes, that have been written, exceeds the configured threshold.

In either case, a temporary file has been created, and all data has been written to the temporary file, erasing all existing data from memory.

### closed

public static final DeferrableOutputStream.State closed
The stream has been closed, and data can no longer be written. It is now valid to invoke `DeferrableOutputStream.getInputStream()`.

## Method Details

### values

public static DeferrableOutputStream.State[] values()
Returns an array containing the constants of this enum type, in the order they are declared.

Returns:
  an array containing the constants of this enum type, in the order they are declared

### valueOf

public static DeferrableOutputStream.State valueOf(String name)
Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum type has no constant with the specified name
  `NullPointerException` - if the argument is null